package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.WFStepActor;
import com.sa.ibiz.demo.demo.domain.WFUser;

/**
 * 实体[WFReminder] 数据对象
 */
@TableName(value = "T_SRFWFREMINDER",resultMap = "WFReminderResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFReminder extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFStepActor wfstepactor;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFUser wfuser;
    @TableField(exist = false)//逻辑属性
    private String actorid;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String memo;
    @TableField(exist = false)//逻辑属性
    private Integer remindercount;
    private Timestamp remindertime;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableField(exist = false)//逻辑属性
    private Timestamp wfcreatedate;
    @TableId(value= "wfreminderid",type=IdType.UUID)//指定主键生成策略
    private String wfreminderid;
    private String wfremindername;
    private String wfstepactorid;
    @TableField(exist = false)//逻辑属性
    private String wfstepactorname;
    private String wfuserid;
    private String wfusername;
    /**
     *  设置属性值[催办对象]
     *  @param actorid
     */
    public void setActorid(String actorid){
        if(StringUtils.isEmpty(actorid))
            actorid=null;
        this.actorid = actorid;
        this.set("actoriddirtyflag",true);
    }
    /**
     *  获取属性值[催办对象]
     */
    public String getActorid(){
        return this.actorid;
    }
    /**
     *  重置属性值[催办对象]
     */
    public void resetActorid(){
        this.set("actoriddirtyflag",false);
        this.actorid = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[催办备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[催办备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[催办备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[已催次数]
     *  @param remindercount
     */
    public void setRemindercount(Integer remindercount){
        this.remindercount = remindercount;
        this.set("remindercountdirtyflag",true);
    }
    /**
     *  获取属性值[已催次数]
     */
    public Integer getRemindercount(){
        return this.remindercount;
    }
    /**
     *  重置属性值[已催次数]
     */
    public void resetRemindercount(){
        this.set("remindercountdirtyflag",false);
        this.remindercount = null;
    }
    /**
     *  设置属性值[催办时间]
     *  @param remindertime
     */
    public void setRemindertime(Timestamp remindertime){
        this.remindertime = remindertime;
        this.set("remindertimedirtyflag",true);
    }
    /**
     *  获取属性值[催办时间]
     */
    public Timestamp getRemindertime(){
        return this.remindertime;
    }
    /**
     *  重置属性值[催办时间]
     */
    public void resetRemindertime(){
        this.set("remindertimedirtyflag",false);
        this.remindertime = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[送交时间]
     *  @param wfcreatedate
     */
    public void setWfcreatedate(Timestamp wfcreatedate){
        this.wfcreatedate = wfcreatedate;
        this.set("wfcreatedatedirtyflag",true);
    }
    /**
     *  获取属性值[送交时间]
     */
    public Timestamp getWfcreatedate(){
        return this.wfcreatedate;
    }
    /**
     *  重置属性值[送交时间]
     */
    public void resetWfcreatedate(){
        this.set("wfcreatedatedirtyflag",false);
        this.wfcreatedate = null;
    }
    /**
     *  设置属性值[工作流工作催办标识]
     *  @param wfreminderid
     */
    public void setWfreminderid(String wfreminderid){
        if(StringUtils.isEmpty(wfreminderid))
            wfreminderid=null;
        this.wfreminderid = wfreminderid;
        this.set("wfreminderiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流工作催办标识]
     */
    public String getWfreminderid(){
        return this.wfreminderid;
    }
    /**
     *  重置属性值[工作流工作催办标识]
     */
    public void resetWfreminderid(){
        this.set("wfreminderiddirtyflag",false);
        this.wfreminderid = null;
    }
    /**
     *  设置属性值[标题]
     *  @param wfremindername
     */
    public void setWfremindername(String wfremindername){
        if(StringUtils.isEmpty(wfremindername))
            wfremindername=null;
        this.wfremindername = wfremindername;
        this.set("wfremindernamedirtyflag",true);
    }
    /**
     *  获取属性值[标题]
     */
    public String getWfremindername(){
        return this.wfremindername;
    }
    /**
     *  重置属性值[标题]
     */
    public void resetWfremindername(){
        this.set("wfremindernamedirtyflag",false);
        this.wfremindername = null;
    }
    /**
     *  设置属性值[工作流催办_操作者]
     *  @param wfstepactorid
     */
    public void setWfstepactorid(String wfstepactorid){
        if(StringUtils.isEmpty(wfstepactorid))
            wfstepactorid=null;
        this.wfstepactorid = wfstepactorid;
        this.set("wfstepactoriddirtyflag",true);
    }
    /**
     *  获取属性值[工作流催办_操作者]
     */
    public String getWfstepactorid(){
        return this.wfstepactorid;
    }
    /**
     *  重置属性值[工作流催办_操作者]
     */
    public void resetWfstepactorid(){
        this.set("wfstepactoriddirtyflag",false);
        this.wfstepactorid = null;
    }
    /**
     *  设置属性值[工作操作者]
     *  @param wfstepactorname
     */
    public void setWfstepactorname(String wfstepactorname){
        if(StringUtils.isEmpty(wfstepactorname))
            wfstepactorname=null;
        this.wfstepactorname = wfstepactorname;
        this.set("wfstepactornamedirtyflag",true);
    }
    /**
     *  获取属性值[工作操作者]
     */
    public String getWfstepactorname(){
        return this.wfstepactorname;
    }
    /**
     *  重置属性值[工作操作者]
     */
    public void resetWfstepactorname(){
        this.set("wfstepactornamedirtyflag",false);
        this.wfstepactorname = null;
    }
    /**
     *  设置属性值[催办者]
     *  @param wfuserid
     */
    public void setWfuserid(String wfuserid){
        if(StringUtils.isEmpty(wfuserid))
            wfuserid=null;
        this.wfuserid = wfuserid;
        this.set("wfuseriddirtyflag",true);
    }
    /**
     *  获取属性值[催办者]
     */
    public String getWfuserid(){
        return this.wfuserid;
    }
    /**
     *  重置属性值[催办者]
     */
    public void resetWfuserid(){
        this.set("wfuseriddirtyflag",false);
        this.wfuserid = null;
    }
    /**
     *  设置属性值[催办者]
     *  @param wfusername
     */
    public void setWfusername(String wfusername){
        if(StringUtils.isEmpty(wfusername))
            wfusername=null;
        this.wfusername = wfusername;
        this.set("wfusernamedirtyflag",true);
    }
    /**
     *  获取属性值[催办者]
     */
    public String getWfusername(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.wfusername)&&(!StringUtils.isEmpty(this.getWfuserid())) && this.getWfuser()!=null)
        {
            this.wfusername = this.getWfuser().getWfusername();
            this.set("wfusernamedirtyflag",true);
        }
        return this.wfusername;
    }
    /**
     *  重置属性值[催办者]
     */
    public void resetWfusername(){
        this.set("wfusernamedirtyflag",false);
        this.wfusername = null;
    }
     /**
     *  获取主实体关联数据[WFStepActor]
     */
    public WFStepActor getWfstepactor() {
        return wfstepactor;
    }
    /**
     *  设置主实体关联数据[WFStepActor]
     */
    public void setWfstepactor(WFStepActor wfstepactor) {
        this.wfstepactor = wfstepactor;
    }

     /**
     *  获取主实体关联数据[WFUser]
     */
    public WFUser getWfuser() {
        return wfuser;
    }
    /**
     *  设置主实体关联数据[WFUser]
     */
    public void setWfuser(WFUser wfuser) {
        this.wfuser = wfuser;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetActorid();
        resetCreatedate();
        resetCreateman();
        resetMemo();
        resetRemindercount();
        resetRemindertime();
        resetUpdatedate();
        resetUpdateman();
        resetWfcreatedate();
        resetWfreminderid();
        resetWfremindername();
        resetWfstepactorid();
        resetWfstepactorname();
        resetWfuserid();
        resetWfusername();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFReminder copyTo(WFReminder targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFReminder.class, WFReminder.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfreminderid();
		return targetEntity;
	}
}